/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of LDAPxs.xs. Do not edit this file, edit LDAPxs.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "LDAPxs.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

/* LDAP C SDK Include Files */
#include <lber.h>
#include <ldap.h>

#include "const-c.inc"

/* Prototypes */
LDAP* _connect(char *, int, int, char *);
void ldap_add_mods(HV*, LDAPMod ***);
void ldapmod_struct(AV*, LDAPMod ***);
void free_attrs(LDAPMod **);
AV* get_entries(LDAP *, LDAPMessage *);
SV* rc_exception(int);

LDAP* 
_connect(char *host, int port, int version, char *scheme)
{
	int rc;
	LDAP* ld = NULL;
	char *ldapuri = NULL;

	LDAPURLDesc url;
	memset( &url, 0, sizeof(url));

	url.lud_scheme = scheme;
	url.lud_host = host;
	url.lud_port = port;
	url.lud_scope = LDAP_SCOPE_DEFAULT;
	ldapuri = ldap_url_desc2str( &url );

	rc = ldap_initialize( &ld, ldapuri );
	if (rc != LDAP_SUCCESS) {
		fprintf( stderr,
				"Could not create LDAP session handle for URI=%s (%d): %s\n",
				ldapuri, rc, ldap_err2string(rc) );
		exit( EXIT_FAILURE );
	}
	if (ldap_set_option(ld, LDAP_OPT_PROTOCOL_VERSION, &version) != LDAP_SUCCESS) {
		fprintf( stderr,
				"Could not set LDAP_OPT_PROTOCOL_VERSION %d\n",
				version );
		exit( EXIT_FAILURE );
	}
	return ld;
}

void
free_attrs(LDAPMod **list_of_attrs)
{
	int i = 0;
	while(list_of_attrs[i] != NULL)
		free(list_of_attrs[i++]->mod_values);
	free(list_of_attrs);
}

void
ldapmod_struct(AV* attrs_av, LDAPMod ***list_of_attrs)
{
/* the data structure of attrs_av is like this
$VAR1 = [
          {
            'type' => 'cn',
		    'vals' => [
		                'buy2',
		                'buy3'
		              ],
		    'changetype' => 0
		  },
		  {
		    'type' => 'ca',
		    'vals' => [
		                'test123'
		              ],
            'changetype' => 0
          }
        ];
*/
	int len, j;

	len = av_len(attrs_av) + 1;
	*list_of_attrs = (LDAPMod **)malloc((len+1)*sizeof(LDAPMod *));
	for (j = 0; j < len; j++) {
		HV* attrs_hv;
		AV *val_array;
		LDAPMod mods;
		SV **elem;
		SV **svp;
		int len_vals, i;

		elem = av_fetch(attrs_av, j, 0);
		if (elem != NULL) {
			attrs_hv = (HV*)SvRV(*elem);
			if ((svp = hv_fetch(attrs_hv, "changetype", 10, FALSE)) && SvIOK(*svp)) {
				mods.mod_op = SvIV(*svp);
			}else{
				croak("changetype is wrong");
			}
			if ((svp = hv_fetch(attrs_hv, "type", 4, FALSE)) && SvPOK(*svp)) {
				mods.mod_type = (char *)SvPV_nolen(*svp);
			}else{
				croak("type is wrong");
			}
			if ((svp = hv_fetch(attrs_hv, "vals", 4, FALSE)) && SvROK(*svp)) {
				val_array = (AV*)SvRV(*svp);
			}else{
				croak("vals is wrong");
			}

			len_vals = av_len(val_array) + 1;
			mods.mod_values = (char **)malloc((len_vals+1)*sizeof(char *));
			for (i = 0; i < len_vals; i++) {
				elem = av_fetch(val_array, i, 0);
				if (elem != NULL) {
					mods.mod_values[i] = (char *)SvPV_nolen(*elem);
				}
			}
			mods.mod_values[i] = NULL;
			/* add the constructed LDAPMod to the list of attrs */
			(*list_of_attrs)[j] = (LDAPMod *)malloc(sizeof(LDAPMod));
			*((*list_of_attrs)[j]) = mods;
		}
	}
	/* list of attrs should be a NULL terminated array */
	(*list_of_attrs)[j] = NULL;
}

/* ldap_add_mods has the same function of ldapmod_struct, but operated in a different way. This function is deprecated */
void
ldap_add_mods(HV* attrs_hv, LDAPMod ***list_of_attrs)
{
	int count, j;

	I32 klen;
	SV *val;

	count = hv_iterinit(attrs_hv);
	*list_of_attrs = (LDAPMod **)malloc((count+1)*sizeof(LDAPMod *));
	for (j = 0; j< count; j++) {
		LDAPMod mods;
		//val = hv_iternextsv(attrs_hv, (char **) &key, &klen);
		mods.mod_op = 0;
		val = hv_iternextsv(attrs_hv, (char **) &mods.mod_type, &klen);
		if (SvTYPE(SvRV(val)) == SVt_PVAV) {
		    /* In case of multi-value */
			AV *val_array = (AV*)SvRV(val);
			int len;
			SV** elem;
			int i;

			len = av_len(val_array) + 1;
			mods.mod_values = (char **)malloc((len+1)*sizeof(char *));
			for (i = 0; i < len; i++) {
				elem = av_fetch(val_array, i, 0);
				if (elem != NULL) {
					mods.mod_values[i] = (char *)SvPV_nolen(*elem);
				}
			}
			mods.mod_values[i] = NULL;
		}else{
			mods.mod_values = (char **)malloc(2*sizeof(char *));
			mods.mod_values[0] = (char *)SvPV_nolen(val);
			mods.mod_values[1] = NULL;
		}
		(*list_of_attrs)[j] = (LDAPMod *)malloc(sizeof(LDAPMod));
		*((*list_of_attrs)[j]) = mods;
	}
	(*list_of_attrs)[j] = NULL;
}


AV*
get_entries(LDAP *ld, LDAPMessage *res)
{
	AV* entries = newAV();

	int i, j, k;
	char *dn, *a;
	LDAPMessage *e;
	BerElement *ptr;
	struct berval **vals;
	struct berval val;

	for(e = ldap_first_entry(ld, res), i = 0; e != NULL; e = ldap_next_entry(ld, e)) { 
		HV* entry_hash;
		AV* attr_array;
		HV* stash;
		SV* object;

		dn = ldap_get_dn(ld, e);
		/* one entry per hash */
		entry_hash = newHV();
		/* attributes array */
		attr_array = newAV();
		for ( a = ldap_first_attribute(ld, e, &ptr), j = 0; a != NULL; a = ldap_next_attribute(ld, e, ptr) ) {
			HV* attr_hash;
			AV* val_array;

			vals = ldap_get_values_len(ld, e, a);
			/* one attribute of an entry */
			attr_hash = newHV();
			/* values of an attribute */
			val_array = newAV();
			for (k = 0; vals[k] != NULL; k++) {
				val = *vals[k];
				av_store(val_array, k, newSVpv(val.bv_val, 0));
			}
			ldap_value_free_len(vals);

			hv_store(attr_hash, "type", 4, newSVpv(a, 0), 0);
			hv_store(attr_hash, "vals", 4, newRV_noinc((SV*)val_array), 0);
			av_store(attr_array, j++, newRV_noinc((SV*)attr_hash));
			ldap_memfree(a);
		}
		hv_store(entry_hash, "objectName", 10, newSVpv(dn, 0), 0);
		hv_store(entry_hash, "attributes", 10, newRV_noinc((SV*)attr_array), 0);
		/* setup a new object called Net::LDAPxs::Entry for every entry */
		stash = gv_stashpv("Net::LDAPxs::Entry", GV_ADDWARN);
		object = newRV_noinc((SV*)entry_hash);
		sv_bless(object, stash);

		av_store(entries, i++, object);

		ldap_memfree(dn);
		if (ptr != NULL)
			ldap_memfree(ptr);
	}
	return entries;
}


SV *
rc_exception(int rc)
{
	HV* stash;
	SV* object;
	HV* exception;

	exception = newHV();
	hv_store(exception, "code", 4, newSViv(rc), 0);
	hv_store(exception, "mesg", 4, newSVpv(ldap_err2string(rc),0),0);

	stash = gv_stashpv("Net::LDAPxs::Exception", GV_ADDWARN);
	object = newRV_inc((SV*)exception);
	sv_bless(object, stash);

	return object;
}


#line 266 "LDAPxs.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 410 "LDAPxs.c"

/* INCLUDE:  Including 'const-xs.inc' from 'LDAPxs.xs' */


XS_EUPXS(XS_Net__LDAPxs_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 435 "LDAPxs.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Net::LDAPxs macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Net::LDAPxs macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Net::LDAPxs macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 513 "LDAPxs.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'LDAPxs.xs' from 'const-xs.inc' */


XS_EUPXS(XS_Net__LDAPxs__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, args_ref");
    {
	SV *	args_ref = ST(1)
;
#line 267 "LDAPxs.xs"
		HV *args;
		char *host;
		int port;
		int version;
		char *scheme;
		SV** svp;
#line 539 "LDAPxs.c"
	LDAP *	RETVAL;
#line 274 "LDAPxs.xs"
		if (SvROK(args_ref) &&
			SvTYPE(SvRV(args_ref)) == SVt_PVHV)
		{
			args = (HV*)SvRV(args_ref);
		}else{
			croak("Usage: Net::LDAPxs->new(HOST, port => PORT)");
		}
		if ((svp = hv_fetch(args, "host", 4, FALSE)) && SvPOK(*svp)) {
			host = (char *)SvPV_nolen(*svp);
		}else{
			croak("_new(host): not a string");
		}
		if ((svp = hv_fetch(args, "port", 4, FALSE)) && SvIOK(*svp)) {
			port = SvIV(*svp);
		}else{
			croak("_new(port): not a number");
		}
		if ((svp = hv_fetch(args, "version", 7, FALSE))  && SvIOK(*svp)) {
			version = SvIV(*svp);
		}else{
			croak("_new(version): not a number");
		}
		if ((svp = hv_fetch(args, "scheme", 6, FALSE)) && SvPOK(*svp)) {
			scheme = (char *)SvPV_nolen(*svp);
		}else{
			croak("_new(scheme): not a string");
		}

		RETVAL = _connect(host, port, version, scheme);
#line 571 "LDAPxs.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Net::LDAPxs", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPxs__bind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs__bind)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, opt");
    {
	LDAP *	ld;
	HV *	opt;
#line 311 "LDAPxs.xs"
		SV** svp;
		int rc;
		char *binddn, *bindpasswd;
		int async;
		int msgid;
		struct berval   passwd = { 0, NULL };

		char *matched = NULL, *errmsg = NULL; 
		char **referrals;
		LDAPControl **resultctrls = NULL;
		LDAPMessage *result;
		struct berval       *servercredp;
#line 605 "LDAPxs.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Net::LDAPxs")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		ld = INT2PTR(LDAP *,tmp);
	} else
		Perl_croak(aTHX_ "ld is not of type Net::LDAPxs")
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    opt = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::LDAPxs::_bind",
				"opt");
		}
	} STMT_END
;
#line 324 "LDAPxs.xs"
		if ((svp = hv_fetch(opt, "binddn", 6, FALSE)) && SvPOK(*svp)) {
			binddn = (char *)SvPV_nolen(*svp);
		}else{
			croak("_bind(binddn): not a string");
		}
		if (hv_exists(opt, "bindpw", 6)) {
			if ((svp = hv_fetch(opt, "bindpw", 6, FALSE)) && SvPOK(*svp)) {
				bindpasswd = (char *)SvPV_nolen(*svp);
				passwd.bv_val = ber_strdup( bindpasswd );
				passwd.bv_len = strlen( passwd.bv_val );
			}else{
				croak("_bind(bindpw): not a string");
			}
		}else{
			bindpasswd = "0";
			passwd.bv_val = ber_strdup( bindpasswd );
			passwd.bv_len = strlen( passwd.bv_val );
		}
		if ((svp = hv_fetch(opt, "async", 5, FALSE)) && SvIOK(*svp)) {
			async = SvIV(*svp);
		}else{
			croak("_bind(async): not a number");
		}

		ldap_set_option( ld, LDAP_OPT_REFERRALS, LDAP_OPT_ON );

		if (async == 0) {
			rc = ldap_sasl_bind_s( ld, binddn, LDAP_SASL_SIMPLE, &passwd, NULL, NULL, &servercredp );
		}else if(async == 1) {
			/* The asynchronous version of this API only supports the LDAP_SASL_SIMPLE mechanism. */
			rc = ldap_sasl_bind( ld, binddn, LDAP_SASL_SIMPLE, &passwd, NULL, NULL, &msgid );
			ldap_result( ld, msgid, LDAP_MSG_ALL, NULL, &result );
			ldap_parse_result( ld, result, &rc, &matched, &errmsg, &referrals, &resultctrls, 0 ); 
		}else{ }
		RETVAL = rc_exception(rc);
#line 664 "LDAPxs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPxs__unbind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs__unbind)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ld");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	LDAP*	ld;

	if (sv_derived_from(ST(0), "Net::LDAPxs")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		ld = INT2PTR(LDAP *,tmp);
	} else
		Perl_croak(aTHX_ "ld is not of type Net::LDAPxs")
;
#line 366 "LDAPxs.xs"
		ldap_unbind_ext(ld, NULL, NULL);
#line 691 "LDAPxs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__LDAPxs__search); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs__search)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, opt");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	LDAP *	ld;
	HV *	opt;
#line 373 "LDAPxs.xs"
		int rc;
		SV** svp;

		char *base;
		int scope;
		char *filter;
		int sizelimit;
		int async;

		SV** elem;
		AV* avref;
		int len = 0;
		char **attrs = NULL;
		LDAPMessage *result;
		AV* entries;

		HV* ctrl;
		int type = 0;
		char *value;
		int critical = 0;

		char *matched = NULL, *errmsg = NULL; 
		char **referrals;
		LDAPControl *sortctrl = NULL;
		LDAPControl *requestctrls[2];
		LDAPControl **resultctrls = NULL;
		LDAPSortKey **sortkeylist;
		int msgid;

		HV* search_result;
		HV* stash;
		SV* blessed_result;
#line 742 "LDAPxs.c"

	if (sv_derived_from(ST(0), "Net::LDAPxs")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		ld = INT2PTR(LDAP *,tmp);
	} else
		Perl_croak(aTHX_ "ld is not of type Net::LDAPxs")
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    opt = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::LDAPxs::_search",
				"opt");
		}
	} STMT_END
;
#line 406 "LDAPxs.xs"
		if ((svp = hv_fetch(opt, "base", 4, FALSE)) && SvPOK(*svp)) {
			base = (char *)SvPV_nolen(*svp);
		}else{
			croak("_search(base): not a string");
		}
		if ((svp = hv_fetch(opt, "scope", 5, FALSE)) && SvIOK(*svp)) {
			scope = SvIV(*svp);
		}else{
			croak("_search(scope): not a number");
		}
		if ((svp = hv_fetch(opt, "filter", 6, FALSE)) && SvPOK(*svp)) {
			filter = (char *)SvPV_nolen(*svp);
		}else{
			croak("_search(filter): not a string");
		}
		if ((svp = hv_fetch(opt, "sizelimit", 9, FALSE)) && SvIOK(*svp)) {
			sizelimit = SvIV(*svp);
		}else{
			croak("_search(sizelimit): not a number");
		}
		if ((svp = hv_fetch(opt, "async", 5, FALSE)) && SvIOK(*svp)) {
			async = SvIV(*svp);
		}else{
			croak("_search(async): not a number");
		}

		if ((svp = hv_fetch(opt, "attrs", 5, FALSE)) && SvROK(*svp)) {
			int i;
			avref = (AV*)SvRV(*svp);
			len = av_len(avref) + 1;
			if (len == 0) {
				attrs = NULL;
			}else{
				attrs = (char **)malloc((len+1)*sizeof(char *));
				for (i = 0; i < len; i++) {
					elem = av_fetch(avref, i, 0);
					if (elem != NULL) {
						attrs[i] = (char *)SvPV_nolen(*elem);
					}
				}
				attrs[i] = NULL;
			}
		}else{
			attrs = NULL;
		}
		if ((svp = hv_fetch(opt, "control", 7, FALSE))) {
			/* there is a control request */
			if (SvROK(*svp) && SvTYPE(SvRV(*svp)) == SVt_PVHV) {
				ctrl = (HV*)SvRV(*svp);
				if ((svp = hv_fetch(ctrl, "type", 4, FALSE)) && SvIOK(*svp)) {
					type = SvIV(*svp);
				}else{
					croak("_search(ctrl-type): not a number");
				}
				if ((svp = hv_fetch(ctrl, "value", 5, FALSE)) && SvPOK(*svp)) {
					value = (char *)SvPV_nolen(*svp);
				}else{
					croak("_search(ctrl-value): not a string");
				}
				if ((svp = hv_fetch(ctrl, "critical", 8, FALSE)) && SvIOK(*svp)) {
					critical = SvIV(*svp);
				}else{
					croak("_search(ctrl-critical): not a number");
				}
			}else{
				croak("_search(ctrl): control object is not a hash");
			}

		/* Server Side Sorting control */
			ldap_create_sort_keylist( &sortkeylist, value );
			rc = ldap_create_sort_control( ld, sortkeylist, critical, &sortctrl ); 
			if (rc != LDAP_SUCCESS) { 
				fprintf( stderr, "ldap_create_sort_control: %s\n", ldap_err2string(rc) ); 
				ldap_unbind_ext(ld, NULL, NULL);
				exit( EXIT_FAILURE );
			} 
			requestctrls[0] = sortctrl; 
			requestctrls[1] = NULL;
		/* end */
		}else{
			/* there is no control request */
			requestctrls[0] = NULL;
			requestctrls[1] = NULL;
		}

        search_result = newHV();
		EXTEND(SP, 1);
		if (async == 0) {
			/* Synchronous bind request */
			rc = ldap_search_ext_s(ld, base, scope, filter, attrs, 0,
				requestctrls, NULL, LDAP_NO_LIMIT, sizelimit, &result);
			if (requestctrls[0] != NULL) {
			/* free the control */
				ldap_free_sort_keylist( sortkeylist );
				ldap_control_free( sortctrl );
			}

    		if (rc != LDAP_SUCCESS) {
    			PUSHs(sv_2mortal(rc_exception(rc)));
    		}else{
        		free(attrs);
        		entries = get_entries(ld, result);
        		ldap_msgfree(result);

        		hv_store(search_result, "entries", 7, newRV_noinc((SV*)entries), 0);
        		hv_store(search_result, "mesgid", 6, newSViv(len-1), 0);

        		stash = gv_stashpv("Net::LDAPxs::Search", GV_ADD);
        		blessed_result = newRV_inc((SV*)search_result);
        		sv_bless(blessed_result, stash);

        		PUSHs(sv_2mortal(blessed_result));
    		}
		}else if (async == 1) {
			/* Asynchronous bind request */
			rc = ldap_search_ext(ld, base, scope, filter, attrs, 0,
				requestctrls, NULL, LDAP_NO_LIMIT, sizelimit, &msgid);
			ldap_result( ld, msgid, LDAP_MSG_ALL, NULL, &result );
			ldap_parse_result( ld, result, &rc, &matched, &errmsg, &referrals, &resultctrls, 0 );
			if (rc != LDAP_SUCCESS) {
				PUSHs(sv_2mortal(rc_exception(rc)));
			}else{
        		entries = get_entries(ld, result);
        		ldap_msgfree(result);

        		search_result = newHV();
        		hv_store(search_result, "entries", 7, newRV_noinc((SV*)entries), 0);
        		hv_store(search_result, "mesgid", 6, newSViv(len-1), 0);

        		stash = gv_stashpv("Net::LDAPxs::Search", GV_ADD);
        		blessed_result = newRV_inc((SV*)search_result);
        		sv_bless(blessed_result, stash);

        		PUSHs(sv_2mortal(blessed_result));
			}
		}else{ }
#line 901 "LDAPxs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__LDAPxs_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs_count)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, res");
    {
	LDAP *	ld;
	LDAPMessage *	res = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Net::LDAPxs")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		ld = INT2PTR(LDAP *,tmp);
	} else
		Perl_croak(aTHX_ "ld is not of type Net::LDAPxs")
;
#line 550 "LDAPxs.xs"
		RETVAL = ldap_count_entries(ld, res);
#line 929 "LDAPxs.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPxs__add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs__add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, dn, attrs_ref");
    {
	LDAP *	ld;
	char *	dn = (char *)SvPV_nolen(ST(1))
;
	SV*	attrs_ref = ST(2)
;
#line 561 "LDAPxs.xs"
		HV *attrs_hv;
		int rc;
#line 952 "LDAPxs.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Net::LDAPxs")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		ld = INT2PTR(LDAP *,tmp);
	} else
		Perl_croak(aTHX_ "ld is not of type Net::LDAPxs")
;
#line 564 "LDAPxs.xs"
		if (SvROK(attrs_ref) &&
			SvTYPE(SvRV(attrs_ref)) == SVt_PVHV)
		{
			LDAPMod **list_of_attrs; 
			attrs_hv = (HV*)SvRV(attrs_ref);

			ldap_add_mods(attrs_hv, &list_of_attrs);
			rc = ldap_add_ext_s(ld, dn, list_of_attrs, NULL, NULL);
			free_attrs(list_of_attrs);
			RETVAL = rc_exception(rc);
		}else{
			Perl_croak(aTHX_ "The value for option 'attrs' should be a hash ref");
		}
#line 975 "LDAPxs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPxs__modify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs__modify)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, dn, attrs_ref");
    {
	LDAP *	ld;
	char *	dn = (char *)SvPV_nolen(ST(1))
;
	SV*	attrs_ref = ST(2)
;
#line 587 "LDAPxs.xs"
		AV *attrs_av;
		int rc;
#line 998 "LDAPxs.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Net::LDAPxs")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		ld = INT2PTR(LDAP *,tmp);
	} else
		Perl_croak(aTHX_ "ld is not of type Net::LDAPxs")
;
#line 590 "LDAPxs.xs"
		if (SvROK(attrs_ref) &&
			SvTYPE(SvRV(attrs_ref)) == SVt_PVAV)
		{
			LDAPMod **list_of_attrs; 
			attrs_av = (AV*)SvRV(attrs_ref);

			ldapmod_struct(attrs_av, &list_of_attrs);
			rc = ldap_modify_ext_s(ld, dn, list_of_attrs, NULL, NULL);
			free_attrs(list_of_attrs);
			RETVAL = rc_exception(rc);
		}else{
			Perl_croak(aTHX_ "The value for option should be a hash ref");
		}
#line 1021 "LDAPxs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPxs__moddn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs__moddn)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, dn, attrs_ref");
    {
	LDAP *	ld;
	char *	dn = (char *)SvPV_nolen(ST(1))
;
	SV*	attrs_ref = ST(2)
;
#line 613 "LDAPxs.xs"
		SV** svp;
		HV *attrs_hv;

		int rc;

		char *newrdn=NULL;
		char *newSuperior=NULL;
		int deleteoldrdn=0;
#line 1050 "LDAPxs.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Net::LDAPxs")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		ld = INT2PTR(LDAP *,tmp);
	} else
		Perl_croak(aTHX_ "ld is not of type Net::LDAPxs")
;
#line 622 "LDAPxs.xs"
		if (SvROK(attrs_ref) &&
			SvTYPE(SvRV(attrs_ref)) == SVt_PVHV)
		{
			attrs_hv = (HV*)SvRV(attrs_ref);

			if ((svp = hv_fetch(attrs_hv, "newrdn", 6, FALSE)) && SvPOK(*svp)) {
				newrdn = (char *)SvPV_nolen(*svp);
			}else{
				croak("_moddn(newrdn): not a string");
			}
			if ((svp = hv_fetch(attrs_hv, "newsuperior", 11, FALSE)) && SvPOK(*svp)) {
				newSuperior = (char *)SvPV_nolen(*svp);
			}else{
				/* if no "newsuperior" present, use default value. */
			}
			if ((svp = hv_fetch(attrs_hv, "deleteoldrdn", 12, FALSE)) && SvIV(*svp)) {
				deleteoldrdn = SvIV(*svp);
			}else{
				croak("_moddn(deleteoldrdn): not a string");
			}
			rc = ldap_rename_s(ld, dn, newrdn, newSuperior, deleteoldrdn,NULL, NULL);
			RETVAL = rc_exception(rc);
		}else{
			Perl_croak(aTHX_ "The value for option should be a hash ref");
		}
#line 1085 "LDAPxs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPxs__compare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs__compare)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, dn, attr, value");
    {
	LDAP *	ld;
	char *	dn = (char *)SvPV_nolen(ST(1))
;
	char *	attr = (char *)SvPV_nolen(ST(2))
;
	char *	value = (char *)SvPV_nolen(ST(3))
;
#line 658 "LDAPxs.xs"
		struct berval bvalue = { 0, NULL };
		int rc;
#line 1110 "LDAPxs.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Net::LDAPxs")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		ld = INT2PTR(LDAP *,tmp);
	} else
		Perl_croak(aTHX_ "ld is not of type Net::LDAPxs")
;
#line 661 "LDAPxs.xs"
		bvalue.bv_val = strdup( value );
		bvalue.bv_len = strlen( bvalue.bv_val );

		rc = ldap_compare_ext_s(ld, dn, attr, &bvalue, NULL, NULL); 
		free(bvalue.bv_val);
		if (rc == LDAP_COMPARE_TRUE) {
			RETVAL = rc_exception(0);
		}else{
			RETVAL = rc_exception(rc);
		}
#line 1130 "LDAPxs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPxs__delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs__delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, dn");
    {
	LDAP *	ld;
	char *	dn = (char *)SvPV_nolen(ST(1))
;
#line 679 "LDAPxs.xs"
		int rc;
#line 1150 "LDAPxs.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Net::LDAPxs")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		ld = INT2PTR(LDAP *,tmp);
	} else
		Perl_croak(aTHX_ "ld is not of type Net::LDAPxs")
;
#line 681 "LDAPxs.xs"
		rc = ldap_delete_ext_s(ld, dn, NULL, NULL);
		RETVAL = rc_exception(rc);
#line 1162 "LDAPxs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE:  Including 'const-xs.inc' from 'LDAPxs.xs' */


XS_EUPXS(XS_Net__LDAPxs__Control__Sort_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs__Control__Sort_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 1193 "LDAPxs.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Net::LDAPxs macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Net::LDAPxs macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Net::LDAPxs macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 1271 "LDAPxs.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'LDAPxs.xs' from 'const-xs.inc' */


XS_EUPXS(XS_Net__LDAPxs__Control__Sort_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPxs__Control__Sort_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, args_ref");
    {
	SV *	args_ref = ST(1)
;
#line 700 "LDAPxs.xs"
		HV *args;
		char *value;
		int critical;

		SV** svp;
#line 1296 "LDAPxs.c"
	SV *	RETVAL;
#line 706 "LDAPxs.xs"
		if (SvROK(args_ref) &&
			SvTYPE(SvRV(args_ref)) == SVt_PVHV)
		{
			args = (HV*)SvRV(args_ref);
		}else{
			Perl_croak(aTHX_ "Usage: Net::LDAPxs->new(HOST, port => PORT)");
		}
		if ((svp = hv_fetch(args, "value", 5, FALSE)))
			value = (char *)SvPV_nolen(*svp);
		if ((svp = hv_fetch(args, "critical", 8, FALSE)))
			critical = SvIV(*svp);

		RETVAL = rc_exception(0);
#line 1312 "LDAPxs.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Net__LDAPxs); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__LDAPxs)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Net::LDAPxs::constant", XS_Net__LDAPxs_constant);
        newXS_deffile("Net::LDAPxs::_new", XS_Net__LDAPxs__new);
        newXS_deffile("Net::LDAPxs::_bind", XS_Net__LDAPxs__bind);
        newXS_deffile("Net::LDAPxs::_unbind", XS_Net__LDAPxs__unbind);
        newXS_deffile("Net::LDAPxs::_search", XS_Net__LDAPxs__search);
        newXS_deffile("Net::LDAPxs::count", XS_Net__LDAPxs_count);
        newXS_deffile("Net::LDAPxs::_add", XS_Net__LDAPxs__add);
        newXS_deffile("Net::LDAPxs::_modify", XS_Net__LDAPxs__modify);
        newXS_deffile("Net::LDAPxs::_moddn", XS_Net__LDAPxs__moddn);
        newXS_deffile("Net::LDAPxs::_compare", XS_Net__LDAPxs__compare);
        newXS_deffile("Net::LDAPxs::_delete", XS_Net__LDAPxs__delete);
        newXS_deffile("Net::LDAPxs::Control::Sort::constant", XS_Net__LDAPxs__Control__Sort_constant);
        newXS_deffile("Net::LDAPxs::Control::Sort::new", XS_Net__LDAPxs__Control__Sort_new);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
